#include <petscmat.h>
#include <stdio.h>
void insertValueIntoMatrix(Mat A, PetscInt num_value, const PetscInt *row_array, const PetscInt *col_array, const PetscScalar *value_array);
Mat createMatrix();
void insertValueIntoMatrix(Mat A, PetscInt num_value, const PetscInt *row_array, const PetscInt *col_array, const PetscScalar *value_array)
{
    for (PetscInt i = 0; i < num_value; i++)
    {
        PetscInt row = row_array[i];
        PetscInt col = col_array[i];
        PetscScalar value = value_array[i];
        
        MatSetValues(A, 1, &row, 1, &col, &value, INSERT_VALUES);
    }
}
Mat createMatrix()
{
    Mat A;
    int process_index = 0;
    MPI_Comm_rank(MPI_COMM_WORLD, &process_index);
    // 1.allocate matrix
    if (process_index == 0)
    {
        PetscInt global_size = 32;
        PetscInt local_size = 16;
        const PetscInt o_nz = PETSC_DECIDE;
        const PetscInt d_nz = PETSC_DECIDE;
        const PetscInt d_nnz[] = {8, 8, 10, 10, 10, 10, 6, 6, 6, 6, 10, 10, 10, 10, 8, 8};
        const PetscInt o_nnz[] = {0, 0, 0, 0, 0, 0, 0, 0, 4, 4, 4, 4, 4, 4, 2, 2};
        MatCreateAIJ(MPI_COMM_WORLD, local_size, local_size, global_size, global_size, d_nz, d_nnz, o_nz, o_nnz, &A);
    }
    else
    {
        PetscInt global_size = 32;
        PetscInt local_size = 16;
        const PetscInt o_nz = PETSC_DECIDE;
        const PetscInt d_nz = PETSC_DECIDE;
        const PetscInt d_nnz[] = {8, 8, 10, 10, 10, 10, 6, 6, 6, 6, 10, 10, 10, 10, 8, 8};
        const PetscInt o_nnz[] = {2, 2, 4, 4, 4, 4, 4, 4, 0, 0, 0, 0, 0, 0, 0, 0};
        MatCreateAIJ(MPI_COMM_WORLD, local_size, local_size, global_size, global_size, d_nz, d_nnz, o_nz, o_nnz, &A);
    }
    // 2.fill data into matrix
    if (process_index == 0)
    {
        PetscInt num_value = 164;
        const PetscInt row[] = {0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15};
        const PetscInt col[] = {0, 1, 2, 3, 8, 9, 10, 11, 0, 1, 2, 3, 8, 9, 10, 11, 0, 1, 2, 3, 4, 5, 10, 11, 12, 13, 0, 1, 2, 3, 4, 5, 10, 11, 12, 13, 2, 3, 4, 5, 6, 7, 12, 13, 14, 15, 2, 3, 4, 5, 6, 7, 12, 13, 14, 15, 4, 5, 6, 7, 14, 15, 4, 5, 6, 7, 14, 15, 0, 1, 8, 9, 10, 11, 16, 17, 18, 19, 0, 1, 8, 9, 10, 11, 16, 17, 18, 19, 0, 1, 2, 3, 8, 9, 10, 11, 12, 13, 18, 19, 20, 21, 0, 1, 2, 3, 8, 9, 10, 11, 12, 13, 18, 19, 20, 21, 2, 3, 4, 5, 10, 11, 12, 13, 14, 15, 20, 21, 22, 23, 2, 3, 4, 5, 10, 11, 12, 13, 14, 15, 20, 21, 22, 23, 4, 5, 6, 7, 12, 13, 14, 15, 22, 23, 4, 5, 6, 7, 12, 13, 14, 15, 22, 23};
        const PetscScalar value[] = {168.75, 0, 0, 0, 0, 0, 0, 0, 0, 168.75, 0, 0, 0, 0, 0, 0, 0, 0, 168.75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168.75, 0, 0, 0, 0, 0, 0, 0, 0, 168.75, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 168.75, 0, 0, 0, 0, 0, 0, 0, 0, 168.75, 0, 0, 0, 0, 0, 0, 168.75, 0, 0, 0, 0, 150, -25, -100, 25, -25, 25, 0, -25, 0, 0, -25, 150, 25, -50, 0, -50, -25, 0, 0, 0, 0, 0, -100, 25, 300, -50, -100, 25, -50, 25, 0, -25, 0, 0, 0, 0, 25, -50, -50, 300, 25, -50, 25, -100, -25, 0, 0, 0, 0, 0, -100, 25, 300, -50, -100, 25, -50, 25, 0, -25, 0, 0, 0, 0, 25, -50, -50, 300, 25, -50, 25, -100, -25, 0, 0, 0, 0, 0, -100, 25, 150, -25, -25, 0, 0, 0, 0, 0, 25, -50, -25, 150, 25, -50};
        insertValueIntoMatrix(A, num_value, row, col, value);
    }
    else
    {
        PetscInt num_value = 164;
        const PetscInt row[] = {16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 17, 17, 17, 17, 17, 17, 17, 17, 17, 17, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 24, 24, 24, 24, 24, 24, 25, 25, 25, 25, 25, 25, 26, 26, 26, 26, 26, 26, 26, 26, 26, 26, 27, 27, 27, 27, 27, 27, 27, 27, 27, 27, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 29, 29, 29, 29, 29, 29, 29, 29, 29, 29, 30, 30, 30, 30, 30, 30, 30, 30, 31, 31, 31, 31, 31, 31, 31, 31};
        const PetscInt col[] = {16, 17, 18, 19, 24, 25, 26, 27, 8, 9, 16, 17, 18, 19, 24, 25, 26, 27, 8, 9, 16, 17, 18, 19, 20, 21, 26, 27, 28, 29, 8, 9, 10, 11, 16, 17, 18, 19, 20, 21, 26, 27, 28, 29, 8, 9, 10, 11, 18, 19, 20, 21, 22, 23, 28, 29, 30, 31, 10, 11, 12, 13, 18, 19, 20, 21, 22, 23, 28, 29, 30, 31, 10, 11, 12, 13, 20, 21, 22, 23, 30, 31, 12, 13, 14, 15, 20, 21, 22, 23, 30, 31, 12, 13, 14, 15, 16, 17, 24, 25, 26, 27, 16, 17, 24, 25, 26, 27, 16, 17, 18, 19, 24, 25, 26, 27, 28, 29, 16, 17, 18, 19, 24, 25, 26, 27, 28, 29, 18, 19, 20, 21, 26, 27, 28, 29, 30, 31, 18, 19, 20, 21, 26, 27, 28, 29, 30, 31, 20, 21, 22, 23, 28, 29, 30, 31, 20, 21, 22, 23, 28, 29, 30, 31};
        const PetscScalar value[] = {150, -25, -100, 25, -25, 25, 0, -25, -25, 0, -25, 150, 25, -50, 0, -50, -25, 0, 25, -50, -100, 25, 300, -50, -100, 25, -50, 25, 0, -25, 0, -25, -50, 25, 25, -50, -50, 300, 25, -50, 25, -100, -25, 0, -25, 0, 25, -100, -100, 25, 300, -50, -100, 25, -50, 25, 0, -25, 0, -25, -50, 25, 25, -50, -50, 300, 25, -50, 25, -100, -25, 0, -25, 0, 25, -100, -100, 25, 150, -25, -25, 0, 0, -25, -25, 25, 25, -50, -25, 150, 25, -50, -25, 0, 0, -50, -25, 0, 75, -25, -50, 25, 25, -50, -25, 75, 0, -25, 0, -25, -50, 25, -50, 0, 150, -25, -50, 25, -25, 0, 25, -100, 25, -25, -25, 150, 0, -25, 0, -25, -50, 25, -50, 0, 150, -25, -50, 25, -25, 0, 25, -100, 25, -25, -25, 150, 0, -25, 0, -25, -25, 25, -50, 0, 75, 0, -25, 0, 0, -50, 25, -25, 0, 75};
        insertValueIntoMatrix(A, num_value, row, col, value);
    }
    // 3. assemble matrix
    MatAssemblyBegin(A, MAT_FINAL_ASSEMBLY);
    MatAssemblyEnd(A, MAT_FINAL_ASSEMBLY);
    // 4. set attribute to matrix
    MatSetOption(A, MAT_SPD, PETSC_TRUE);
    MatSetBlockSize(A, 2);  // DO NOT USE THIS LINE, EVERY THING WILL BE OK!
    return A;
}
int main(int argc, char ** argv)
{
    char help[] = "";
    PetscInitialize(&argc, &argv, (char *)0, help);
    int process_num = 0;
    MPI_Comm_size(MPI_COMM_WORLD, &process_num);
    if (process_num != 2)
    {
        printf("please run with 2 process.\n");
    }
    Mat A = createMatrix();
    MatView(A, PETSC_VIEWER_STDOUT_(MPI_COMM_WORLD));
    Mat J;
    MatConvert(A, MATIS, MAT_INITIAL_MATRIX, &J);
    return 0;
}